﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinSpellChecker;

namespace _108064
{
    public partial class Form2 : Form
    {
        // table which contines spelling erros
        DataTable errData = new DataTable("Error");

        bool NoErrorWareFound = false;

        Control currSpeledControl;

        private Control CurrSpeledControl
        {
            get { return currSpeledControl; }
            set
            {
                currSpeledControl = value;
                // fill the address of current speling cell
                if (value != null)
                    lblSpelingCellAddress.Text = string.Format("Spelling Control Name: {0}", currSpeledControl.Name);
                else
                    lblSpelingCellAddress.Text = "Spelling Cell Address";
            }
        }
        private object ChekedText
        {
            get
            {
                return ultraFormattedTextEditor1.Value;
            }
            set
            {
                ultraFormattedTextEditor1.Value = value;
            }
        }

        List<Control> controlsForSpelling;

        List<Error> ignorError = new List<Error>();

        // generate data schema for the erro table
        private void InitializeErrData()
        {
            errData.Columns.Add("ErrID", typeof(int)).AutoIncrement = true;
            errData.Columns.Add("Error", typeof(object));
            ultraGrid1.DataSource = errData;

        }

        // populate error table with find errors
        private void FillErrData(ErrorCollection errColection)
        {
            errData.Rows.Clear();
            foreach (Error err in errColection)
            {
                if (!ignorError.Contains(err))
                    errData.Rows.Add(null, err);
                
            }

            if (ultraGrid1.Rows.Count > 0)
                ultraGrid1.ActiveCell = ultraGrid1.Rows[0].Cells["Error"];
            else
            {
                // move to the next cell for spelling 
                CurrSpeledControl = NextContolForSpelling();
                if (CurrSpeledControl != null)
                {
                    ChekedText = CurrSpeledControl.Text;
                    FillErrData(ultraSpellChecker1.CheckText(CurrSpeledControl.Text));
                }
                else
                {
                    // spellimg completed 
                    ResetComponent();
                    MessageBox.Show("Speling compleat", "Information",
                         MessageBoxButtons.OK, MessageBoxIcon.Information);
                    this.DialogResult = System.Windows.Forms.DialogResult.OK;
                    this.Close();
                }
            }
        }

        private void ResetComponent()
        {
            listBox1.Items.Clear();
            ChanageText.Text = null;
            ChanageText.Enabled = false;
            btnChange.Enabled = false;
            btnIgnor.Enabled = false;
            ultraFormattedTextEditor1.EditInfo.SelectionStart = -1;
            ultraFormattedTextEditor1.EditInfo.SelectionLength = -1;

        }

        public Form2(List<Control> controlsForSpelling)
        {
            InitializeComponent();
            this.controlsForSpelling = controlsForSpelling;
            // find fistr cell for spelling
            CurrSpeledControl = FirstControlForSpelling();
            if (CurrSpeledControl != null)
            {
                this.ChekedText = CurrSpeledControl.Text;
                InitializeErrData();
                FillErrData(ultraSpellChecker1.CheckText(CurrSpeledControl.Text));
            }
            else
            {
                // spellimg completed 
                ResetComponent();
                MessageBox.Show("No Speling errors ware found", "Information",
                     MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.DialogResult = System.Windows.Forms.DialogResult.OK;
                NoErrorWareFound = true;
            }
        }


        private void Form2_Load(object sender, EventArgs e)
        {
            if (NoErrorWareFound)
                this.Close();
        }


        private Control FirstControlForSpelling()
        {
            int Index = 0;
            Control retControl = null;
            while (Index < controlsForSpelling.Count && retControl == null)
            {
                if (ultraSpellChecker1.CheckText(controlsForSpelling[Index].Text).Count > 0)
                {
                    retControl = controlsForSpelling[Index];
                }
                Index++;
            }
            return retControl;
        }

        private Control NextContolForSpelling()
        {
            ignorError.Clear();
            int Index = this.controlsForSpelling.IndexOf(CurrSpeledControl);// CurrSpeledCell.Row.Index;
            Control retControl = null;
            while (Index < controlsForSpelling.Count && retControl == null)
            {
                if (ultraSpellChecker1.CheckText(controlsForSpelling[Index].Text).Count > 0)
                {
                    retControl = controlsForSpelling[Index];
                }
                Index++;
            }
            return retControl;
        }

        private void ultraGrid1_AfterCellActivate(object sender, EventArgs e)
        {
            Error err = (Error)ultraGrid1.ActiveCell.Value;
            // select cuurent spelling word
            ultraFormattedTextEditor1.EditInfo.SelectionStart = err.StartIndex;
            ultraFormattedTextEditor1.EditInfo.SelectionLength = err.CheckedWord.Length;

            //populate list with suggestions
            listBox1.Items.Clear();
            foreach (string s in err.Suggestions)
                listBox1.Items.Add(s);
            if (listBox1.Items.Count > 0)
            {
                ChanageText.Enabled = true;
                btnChange.Enabled = true;
                btnIgnor.Enabled = true;
                listBox1.SelectedIndex = 0;

            }
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["ErrID"].CellActivation = Activation.Disabled;
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            ChanageText.Text = listBox1.SelectedItem.ToString();
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            // replace misspelled word
            string s = ultraFormattedTextEditor1.Text;
            int sindex = ultraFormattedTextEditor1.EditInfo.SelectionStart;
            s = s.Remove(ultraFormattedTextEditor1.EditInfo.SelectionStart, ultraFormattedTextEditor1.EditInfo.SelectionLength);
            s = s.Insert(sindex, this.ChanageText.Text);

            ultraFormattedTextEditor1.Value = s;
            ultraFormattedTextEditor1.Text = s;
            //udate cell value 
            CurrSpeledControl.Text = s;

            FillErrData(ultraSpellChecker1.CheckText(CurrSpeledControl.Text));


        }

        private void ultraButton1_Click_1(object sender, EventArgs e)
        {
            if (ultraGrid1.ActiveCell != null)
            {
                this.ignorError.Add((Error)ultraGrid1.ActiveCell.Value);
                FillErrData(ultraSpellChecker1.CheckText(CurrSpeledControl.Text));
            }
        }



    }
}
